#include "testlib.h"

using namespace std;

typedef unsigned long long ull;

int main(int argc, char *argv[]) {

    registerInteraction(argc, argv);

    ull p = inf.readLong();
    int mode = inf.readInt();
    int w = 0, counter = 0;

    ull const P2_LIMIT = 1000'000;
    ull const P_LIMIT = P2_LIMIT * P2_LIMIT;
    int queries = 0;
    int const Q_LIMIT = 22;

#define FAIL(msg) cout << "BOOM\n"; cout.flush(); quitf(_wa, msg);

    while (true) {
        string cmd = ouf.readToken("ADVICE|EXPERIMENT|SUCCESS", format("query #%d", queries + 1));
        if (cmd == "SUCCESS") {
            ull guess = ouf.readLong(0, P_LIMIT, "p_guess");
            if (guess == p) {
                cout << "OK\n";
                cout.flush();
                tout << queries << '\n';
                quitf(_ok, "correct, %d queries", queries);
            } else {
                FAIL("wrong guess")
            }
        }
        if (++queries > Q_LIMIT) {
            FAIL("too many queries (more than 40)")
        }

        if (cmd == "ADVICE") {
            ull t = ouf.readLong(0, P2_LIMIT, format("adv t #%d", queries));
            if (p <= t * t && t < p) {
                cout << "YES\n";
            } else {
                cout << "NO\n";
            }
            cout.flush();
        } else {
            ull t = ouf.readLong(0, P_LIMIT, format("exp t #%d", queries));
            if (t > p) {
                FAIL("guess exceeded p")
            } else {
                double ratio = static_cast<long double>(p) / t;
                int w_signed = rnd.next(2) ? w : -w;
                double x = ratio > 1.0 ? rnd.wnext(ratio, ratio * ratio, w_signed) : 1.0;
                if (++counter % mode == 0) w++;
                cout << format("OK %.18f\n", x);
                cout.flush();
            }
        }
    }

}