/*
    @author: doreshnikov
    Daniil Oreshnikov, ITMO University
*/

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned int uint;
typedef pair<int, int> pii;

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &p) {
    return in >> p.first >> p.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &item : v)
        in >> item;
    return in;
}

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}
#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

#define all(c) c.begin(), c.end()

typedef unsigned long long ull;
typedef long double ld;

int main() {

#define SUBMIT(p) cout << "SUCCESS " << p << '\n'; cout.flush(); return 0;

    ull l = 1, r = 1000'000'000'000;

    string response;
    auto dist = [&](ull x) {
        if (x > 1000'000) return numeric_limits<ld>::max();
        ld xd = x - 1, xxd = x * x - 1;
        if (x - 1 <= l && x * x - 1 < r) return max(xxd / l, r / xxd);
        if (x - 1 > l && x * x - 1 >= r) return max(xd / l, r / xd);
        return numeric_limits<ld>::max();
    };

    while (r - l > 1) {
        ull bsq_ceil = ceil(sqrt(l) * sqrt(r)), bsq_floor = floor(sqrt(l) * sqrt(r));
        vector<pair<ld, ull>> d{
                {dist(l),                  l},
                {dist(floor(sqrt(r)) + 1), floor(sqrt(r)) + 1},
                {dist(bsq_ceil),           bsq_ceil},
                {dist(bsq_floor),          bsq_floor}
        };
        auto dp = *min_element(all(d));

        ld item = l + (r - l) / 2.0;
        ld ratio = static_cast<ld>(item) / l;
        ld expect = 0.5 * (ratio + ratio * ratio);

        ld exp_r = min(static_cast<ld>(r), floor(expect * l));
        ld exp_l = max(static_cast<ld>(l), floor(sqrt(expect) * l));
#ifdef LOCAL
        cout << l << "/" << r << " vs " << exp_l << "/" << exp_r << '\n';
#endif

        if (exp_r / exp_l <= dp.first) {
            cout << "EXPERIMENT " << l << '\n';
            cout.flush();
            cin >> response;

            if (response == "BOOM") return 0;
            in(long double, x)
            ull new_r = static_cast<ull>(floor(x * l));
            if (static_cast<ld>(r) / l > x) r = new_r;
            ull new_l = static_cast<ull>(floor(sqrt(x) * l));
            if (new_l > l) l = new_l;
        } else {
            cout << "ADVICE " << dp.second << '\n';
            cout.flush();
            cin >> response;

            if (response == "YES") {
                l = max(l, dp.second - 1);
                r = min(r, dp.second * dp.second - 1);
            } else if (response == "NO") {
                if (dp.second - 1 < l) {
                    r = min(r, dp.second * dp.second - 1);
                } else {
                    l = max(l, dp.second - 1);
                }
            } else {
                return 0;
            }
        }
    }
    SUBMIT(r)

}