#include "testlib.h"

using namespace std;

typedef long long ll;
const int MAX_QUERIES = 50;

int readAnswer(InStream &inStream, int n, const vector<pair<int, int>> &a) {
    bool answer = inStream.readToken("YES|NO", "ans") == "YES";

    if (answer) {
        vector<int> order = inStream.readInts(n, 1, n, "a_i");
        inStream.ensuref(set<int>(order.begin(), order.end()).size() == n,
                         "positions in placement should be unique");
        for (int i = 0; i < n; ++i) {
            inStream.ensuref(a[order[i] - 1].first <= i + 1 && i + 1 <= a[order[i] - 1].second,
                             "constrains not satisfied for %d at position %d: %d <= %d <= %d", order[i], i + 1,
                             a[order[i] - 1].first, i + 1, a[order[i] - 1].second);
        }
    }

    return answer;
}

int main(int argc, char *argv[]) {
    registerTestlibCmd(argc, argv);

    int n = inf.readInt();


    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; ++i) {
        a[i].first = inf.readInt(1, n, "li");
        a[i].second = inf.readInt(1, n, "ri");
    }

    bool juryAnswer = readAnswer(ans, n, a);
    bool pAnswer = readAnswer(ouf, n, a);

    if (juryAnswer && !pAnswer) {
        quitf(_wa, "participant didn't find answer, but it exists");
    } else if (!juryAnswer && pAnswer) {
        quitf(_fail, "jury didn't find answer, but it found participant");
    }
    quitf(_ok, "%s", juryAnswer ? "YES" : "NO");
}
