using namespace std;

#include <iostream>
#include <iomanip>
#include <vector>
#include <queue>
#include <unordered_set>
#include <algorithm>
#include <functional>

using ll = long long;
using answer = pair<double, int>;

bool test(int n, vector<int> &order, vector<bool> &used, const vector<pair<int, int>> &a) {
    if (order.size() == n) {
        for (int i = 0; i < n; ++i) {
            if (a[order[i]].first > i + 1 || a[order[i]].second < i + 1) {
                return false;
            }
        }
        return true;
    }

    for (int i = 0; i < n; ++i) {
        if (used[i]) continue;
        used[i] = true;
        order.push_back(i);
        if (test(n, order, used, a)) {
            return true;
        }
        order.pop_back();
        used[i] = false;
    }
    return false;
}

int main() {
    int n;
    cin >> n;

    vector <pair<int, int>> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first >> a[i].second;
    }

    vector<int> order;
    vector<bool> used(n);
    if (!test(n, order, used, a)) {
        cout << "NO\n";
        return 0;
    }

    cout << "YES\n";
    for (int i = 0; i < n; ++i) {
        cout << order[i] + 1 << " ";
    }
    cout << "\n";
}