using namespace std;

#include <iostream>
#include <unordered_set>
#include <unordered_map>
#include "jngen.h"

typedef long long ll;

const ll MAX_D = 1000000000;

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);
    parseArgs(argc, argv);

    const int max_n = getOpt("n");
    int n = 1 + rnd.wnext(max_n, 10);

    const int max_d = getOpt<int>("d", MAX_D);

    auto t = Tree::random(n).shuffle();
    int s = rnd.next(1, n);

    auto a = Array64::random(n, 1, max_d);
    auto b = Array64::random(n, 1, max_d);

    printf("%d %d\n", n, s);

    for (int i = 0; i < n; ++i) {
        if (i > 0) {
            printf(" ");
        }
        printf("%lld", a[i]);
    }
    printf("\n");

    for (int i = 0; i < n; ++i) {
        if (i > 0) {
            printf(" ");
        }
        printf("%lld", b[i]);
    }
    printf("\n");

    for (auto e : t.edges()) {
        printf("%d %d\n", e.first + 1, e.second + 1);
    }
    return 0;
}
