/*
    @author: doreshnikov
    Daniil Oreshnikov, ITMO University
*/

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned int uint;
typedef pair<int, int> pii;

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &p) {
    return in >> p.first >> p.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &item : v)
        in >> item;
    return in;
}

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}
#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

#define all(c) c.begin(), c.end()

struct qmin {
    deque<int> values;
    deque<int> mins;

    void push(int v) {
        values.push_back(v);
        while (!mins.empty() && mins.back() > v) {
            mins.pop_back();
        }
        mins.push_back(v);
    }

    int pop() {
        int v = values.front();
        values.pop_front();
        if (mins.front() == v) {
            mins.pop_front();
        }
    }

    int min() {
        return mins.empty() ? static_cast<int>(1e9) : mins.front();
    }

    int size() {
        return values.size();
    }
};

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    in(int, n, a, b);

    vector<int> high(n), low(n);
    for (int i = 0; i < n; i++) {
        cin >> low[i] >> high[i];
    }

    int ans = 1;
    qmin highs, lows;
    int r = 0;

    for (int l = 0; l < n; l++) {
        while (r < n && -lows.min() < highs.min()) {
            lows.push(-low[r]);
            highs.push(high[r]);
            r++;
        }
        ans = max(ans, r - l - 1);
        if (r == n) break;
        lows.pop();
        highs.pop();
    }
    if (-lows.min() < highs.min()) {
        ans = max(ans, lows.size());
    }

    cout << ans * 1ll * b << '\n';

}