#include <iostream>
#include <unordered_set>
#include <unordered_map>
#include "testlib.h"

using namespace std;

typedef long long ll;
using seg = pair<int, int>;
using point = tuple<int, int, ll>;

const ll MAX_D = 1000000000LL;


int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    const int h = opt<int>("h");
    const int w = opt<int>("w");
    int n = opt<int>("n");
    const ll max_d = has_opt("d") ? opt<ll>("d") : MAX_D;

    const double bw = has_opt("bw") ? opt<double>("bw") : 0.3;

    vector<seg> main_path(h);
    main_path[0].first = 0;
    main_path[0].second = rnd.next(1, w);
    for (int y = 1; y < h - 1; ++y) {
        if (main_path[y - 1].first + 1 < main_path[y - 1].second) {
            int xl = rnd.next(0, main_path[y - 1].second - 1);
            int xr = rnd.next(main_path[y - 1].first + 1, w);
            if (xl == xr) {
                xr += 1;
            } else if (xr < xl) {
                swap(xl, xr);
            }
            main_path[y].first = xl;
            main_path[y].second = xr;
        } else {
            main_path[y].first = rnd.next(0, main_path[y - 1].first);
            main_path[y].second = rnd.next(main_path[y - 1].second, w);
        }
    }
    main_path[h - 1].first = rnd.next(0, main_path[h - 2].second - 1);
    main_path[h - 1].second = w;
//    for (int i = 0; i < h; ++i) {
//        cout << main_path[i].first << " " << main_path[i].second << "\n";
//    }

    vector<point> points;
    set<pair<int, int>> pointsm;

    for (int i = 0; i < n; ++i) {
        for (int rq = 0; rq < 100; ++rq) {
            if (rnd.next() < bw) {
                int y = rnd.next(0, h - 1);
                int x = rnd.next(0, w - 1);
                if (pointsm.find(make_pair(x, y)) != pointsm.end()) {
                    continue;
                }
                ll d = rnd.next(1LL, max_d);
                points.emplace_back(y, x, d);
                pointsm.emplace(x, y);
            } else {
                int y = rnd.next(0, h - 1);
                int x;
                int mpl = main_path[y].first;
                int mpr = main_path[y].second;
                if (mpl - 1 >= 0 && pointsm.find(make_pair(mpl - 1, y)) == pointsm.end()) {
                    x = mpl - 1;
                } else if (mpr < w && pointsm.find(make_pair(mpr, y)) == pointsm.end()) {
                    x = mpr;
                } else if (w > (mpr - mpl)) {
                    x = rnd.next(0, w - (mpr - mpl) - 1);
                    if (x >= mpl) x += mpr - mpl;
                    if (pointsm.find(make_pair(x, y)) != pointsm.end()) {
                        continue;
                    }
                } else {
                    continue;
                }
                points.emplace_back(y, x, -1);
                pointsm.emplace(x, y);
            }
            break;
        }
    }
    n = static_cast<int>(points.size());
    sort(points.begin(), points.end());

    printf("%d %d %d\n", h, w, n);
    for (int i = 0; i < n; ++i) {
        int y = get<0>(points[i]) + 1;
        int x = get<1>(points[i]) + 1;
        if (get<2>(points[i]) == -1) {
            printf("%d %d #\n", y, x);
        } else {
            printf("%d %d + %lld\n", y, x, get<2>(points[i]));
        }
    }

    return 0;
}
