using namespace std;

#include <iostream>
#include <iomanip>
#include <vector>
#include <queue>
#include <unordered_set>
#include <algorithm>
#include <functional>

using ll = long long;
using segment = tuple<int, int, ll, ll>;

const ll MAX = LLONG_MAX;

int main() {
    int h, w, n;

    cin >> h >> w >> n;

    vector <vector<int>> blocked(h);
    vector < vector < pair < int, ll>>> bonuces(h);

    for (int i = 0; i < n; ++i) {
        char t;
        int x, y;
        cin >> y >> x >> t;
        --x, --y;
        ll d = -1;
        if (t == '+') {
            cin >> d;
            bonuces[y].emplace_back(x, d);
        } else {
            blocked[y].push_back(x);
        }
    }
    for (int y = 0; y < h; ++y) {
        sort(blocked[y].begin(), blocked[y].end());
        sort(bonuces[y].begin(), bonuces[y].end());
    }

    vector <vector<segment>> a(h);
    vector <vector<segment>> dp(h);
    for (int y = 0; y < h; ++y) {
        if (!blocked[y].empty() && 0 < blocked[y][0]) {
            a[y].emplace_back(0, blocked[y][0], 0, -1);
        }
        for (int i = 1; i < blocked[y].size(); ++i) {
            if (blocked[y][i - 1] + 1 < blocked[y][i]) {
                a[y].emplace_back(blocked[y][i - 1] + 1, blocked[y][i], 0, -1);
            }
        }
        if (blocked[y].empty() || blocked[y].back() < w - 1) {
            a[y].emplace_back(blocked[y].empty() ? 0 : blocked[y].back() + 1, w, 0, -1);
        }

        int si = 0;
        for (const auto q: bonuces[y]) {
            while (si + 1 < a[y].size() && get<0>(a[y][si + 1]) <= q.first) {
                ++si;
            }
            get<2>(a[y][si]) += q.second;
        }

//        for (auto t: a[y]) {
//            cout << get<0>(t) << "-" << get<1>(t) << "(" << get<2>(t) << "), ";
//        }
//        cout << "\n";
    }
    get<3>(a[0][0]) = get<2>(a[0][0]);

    for (int y = 1; y < h; ++y) {
        int si = 0;
        for (int c = 0; c < a[y].size(); ++c) {
            get<3>(a[y][c]) = -1;
            ll p = -1;
            while (si < a[y - 1].size() && get<1>(a[y - 1][si]) <= get<0>(a[y][c])) {
                ++si;
            }
            if (si >= a[y - 1].size() || get<0>(a[y - 1][si]) >= get<1>(a[y][c])) {
                continue;
            }
            while (true) {
//                cout << "seg " << get<0>(a[y][c]) << " " << get<1>(a[y][c]) << " from " <<
//                        get<0>(a[y - 1][si]) << " "<< get<1>(a[y - 1][si]) << "\n";
                p = max(p, get<3>(a[y - 1][si]));
                if (si + 1 < a[y - 1].size() && get<0>(a[y - 1][si + 1]) < get<1>(a[y][c])) {
                    ++si;
                    continue;
                    //get<1>(a[y - 1][si]) <= get<1>(a[y][c])
                }
                break;
            }
            if (p > -1) {
                get<3>(a[y][c]) = p + get<2>(a[y][c]);
            }
        }
    }


    cout << get<3>(a[h - 1].back()) << "\n";
}