using namespace std;

#include <iostream>
#include <unordered_set>
#include <unordered_map>
#include "jngen.h"

typedef long long ll;

const ll MAX_M = 1000000;
const ll MAX_C = 10000000;
const ll MAX_W = 10000000;

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);
    parseArgs(argc, argv);

    const int n = getOpt("n");
    const int max_m = getOpt("m", MAX_M);
    int m = max(n - 1, 1 + rnd.wnext((int) min((ll) max_m, (ll) n * (n - 1) / 2), 10));

    ll max_c = getOpt("c", MAX_C);
    ll max_w = getOpt("w", MAX_W);

    auto c = Array64::random(n, 1L, max_c);

    vector <ll> w;
    vector <pair<int, int>> edges;

    set <pair<int, int>> was_edge;
    auto t = Array::randomUnique(n, n);
    for (int i = 1; i < n; ++i) {
        int u = t[i - 1];
        int v = t[i];
        if (u > v) swap(u, v);
        was_edge.emplace(u, v);
        edges.emplace_back(u, v);
        w.push_back(1);
    }

    for (int i = n - 1; i < m; ++i) {
        int u, v;
        while (true) {
            u = rnd.next(0, n - 1);
            v = rnd.next(0, n - 2);
            v = v < u ? v : v + 1;
            if (was_edge.find(make_pair(min(u, v), max(u, v))) == was_edge.end()) {
                break;
            }
        }
        was_edge.emplace(min(u, v), max(u,v));
        edges.emplace_back(u, v);
        w.push_back(rnd.next(2LL, max_w));
    };

    printf("%d %d\n", n, m);

    for (int i = 0; i < n; ++i) {
        if (i > 0) {
            printf(" ");
        }
        printf("%lld", c[i]);
    }
    printf("\n");

    for (int i = 0; i < m; ++i) {
        printf("%d %d %lld\n", edges[i].first + 1, edges[i].second + 1, w[i]);
    }
    return 0;
}
