using namespace std;

#include <iostream>
#include <unordered_set>
#include <unordered_map>
#include "jngen.h"

typedef long long ll;

const ll MAX_M = 1000000;
const ll MAX_C = 10000000;
const ll MAX_W = 10000000;

int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);
    parseArgs(argc, argv);

    const int max_n = getOpt("n");
    int n = 1 + rnd.wnext(max_n, 10);
    const int max_m = getOpt("m", MAX_M);
    int m = max(n - 1, 1 + rnd.wnext((int) min((ll) max_m, (ll) n * (n - 1) / 2), 10));

    ll max_c = getOpt("c", MAX_C);
    ll max_w = getOpt("w", MAX_W);

    auto g = Graph::random(n, m).connected().g().shuffle();
    auto edges = g.edges();
    auto w = Array64::random(m, 1L, max_w);

    auto c = Array64::random(n, 0LL , max_c);

    printf("%d %d\n", n, m);

    for (int i = 0; i < n; ++i) {
        if (i > 0) {
            printf(" ");
        }
        printf("%lld", c[i]);
    }
    printf("\n");

    for (int i = 0; i < m; ++i) {
        printf("%d %d %lld\n", edges[i].first + 1, edges[i].second + 1, w[i]);
    }
    return 0;
}
