#include <functional>
#include <algorithm>
#include "testlib.h"

using namespace std;

const int MAX_N = 250;
const int MAX_M = 40000;
const int MAX_C = 10'000'000;
const int MAX_W = 10'000'000;

int main(int argc, char *argv[]) {
    registerValidation(argc, argv);

    int n = inf.readInt(1, MAX_N, "n");
    inf.readSpace();
    int m = inf.readInt(1, min(MAX_M, n * (n - 1) / 2), "m");
    inf.readEoln();

    inf.readInts(n, 0, MAX_C, "c_i");
    inf.readEoln();

    set<pair<int, int>> edges;

    for (int i = 0; i < m; ++i) {
        int u = inf.readInt(1, n, "u_i");
        inf.readSpace();
        int v = inf.readInt(1, n, "v_i");
        inf.readSpace();
        inf.readInt(1LL, MAX_W, "w_i");
        inf.readEoln();
        ensuref(u != v, "edge for node %d should not be loop", u);
        if (u > v) swap(u, v);
        ensuref(edges.find(make_pair(u, v)) == edges.end(), "edge from %d to %d should be unique", u, v);
        edges.emplace(u, v);
    }
    inf.readEof();
}