using namespace std;

#include <iostream>
#include <iomanip>
#include <vector>
#include <queue>
#include <unordered_set>
#include <algorithm>
#include <functional>

using ll = long long;

const ll MAX = LLONG_MAX;

int main() {
    int n, m;

    cin >> n >> m;

    vector <vector<ll>> d(n, vector<ll>(n, MAX));
    vector<int> a(n);

    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }

    for (int i = 0; i < m; ++i) {
        int u, v;
        ll w;
        cin >> u >> v >> w;
        --v, --u;
        d[u][v] = w;
        d[v][u] = w;
    }
    for (int i = 0; i < n; ++i) {
        d[i][i] = 0;
    }

    for (int i = 0; i < n; ++i) {
        for (int u = 0; u < n; ++u) {
            for (int v = 0; v < n; ++v) {
                if (d[u][i] < MAX && d[i][v] < MAX) {
                    d[u][v] = min(d[u][v], d[u][i] + d[i][v]);
                }
            }
        }
    }

    pair<ll, int> ans(MAX, -1);
    for (int c = 0; c < n; ++c) {
        ll s = 0;
        for (int i = 0; i < n; ++i) {
            s += d[c][i] * a[i];
        }
        ans = min(ans, make_pair(s, c));
    }
//    cout << ans.second + 1 << " " << ans.first << "\n";
    cout << ans.first << "\n";
}