#include "testlib.h"
#include <unordered_set>

using namespace std;

int n, s, depth, range;
unordered_map<string, int> values;
vector<string> vars;
unordered_set<string> loop_vars;
vector<string> lines;

string var_name(bool add = true) {
    string name;
    do {
        name = "";
        for (int t = 0; t < 10; t++) {
            char c = rnd.next('a', 'z');
            while (c == 'x' || c == 'r') {
                c = rnd.next('a', 'z');
            }
            name += c;
        }
    } while (values.count(name));
    if (add) {
        vars.push_back(name);
    }
    return name;
}

void print_loop(int d, string indent);

void print_block(int d, string const &indent) {
    int op_type = rnd.next(4);
    string loc_var = vars.empty() ? var_name() : vars[rnd.wnext(0, (int) vars.size() - 1, 3)];
    if (op_type == 0 && vars.size() > 1) {
        lines.push_back(indent + format("print(%s)", loc_var.c_str()));
    } else if (op_type == 1) {
        if (loop_vars.count(loc_var)) {
            loc_var = var_name();
        }
        lines.push_back(indent + format("read(%s)", loc_var.c_str()));
    } else if (d < depth && op_type == 2) {
        if (vars.size() == 1) vars.clear();
        print_loop(d + 1, indent);
    } else {
        int assign_type = rnd.next(4);
        if (loop_vars.count(loc_var)) {
            loc_var = var_name();
        }
        if (assign_type == 0 && vars.size() > 2) {
            string loc_var_2 = vars[rnd.wnext(0, (int) vars.size() - 1, 3)];
            while (loc_var_2 == loc_var) loc_var_2 = vars[rnd.wnext(0, (int) vars.size() - 1, 3)];
            string loc_var_3 = vars[rnd.wnext(0, (int) vars.size() - 1, 3)];
            while (loc_var_3 == loc_var) loc_var_3 = vars[rnd.wnext(0, (int) vars.size() - 1, 3)];
            string sign = rnd.next(2) ? "+" : "-";
            lines.push_back(indent + format("%s = %s %s %s", loc_var.c_str(), loc_var_3.c_str(), sign.c_str(),
                                            loc_var_2.c_str()));
        } else if (assign_type == 1 && vars.size() > 1) {
            string loc_var_2 = vars[rnd.wnext(0, (int) vars.size() - 1, 3)];
            while (loc_var_2 == loc_var) loc_var_2 = vars[rnd.wnext(0, (int) vars.size() - 1, 3)];
            string sign = rnd.next(2) ? "+" : "-";
            lines.push_back(indent + format("%s = %s %s %d", loc_var.c_str(), loc_var_2.c_str(), sign.c_str(),
                                            rnd.next(1, 7)));
        } else if (assign_type == 2 && vars.size() > 1) {
            string loc_var_2 = vars[rnd.wnext(0, (int) vars.size() - 1, 3)];
            while (loc_var_2 == loc_var) loc_var_2 = vars[rnd.wnext(0, (int) vars.size() - 1, 3)];
            string sign = rnd.next(2) ? "+" : "-";
            lines.push_back(indent + format("%s = %d %s %s", loc_var.c_str(), rnd.next(1, 7), sign.c_str(),
                                            loc_var_2.c_str()));
        } else {
            if (rnd.next(2)) {
                lines.push_back(indent + format("%s = %d", loc_var.c_str(), rnd.next(1, 100)));
            } else {
                lines.push_back(indent + format("%s = %d + %d", loc_var.c_str(), rnd.next(1, 10), rnd.next(0, 20)));
            }
        }
    }
}

void print_loop(int d, string indent) {
    if (lines.size() + 2 > n) return;
    int loop_type = rnd.next(4);
    string var = var_name(false);
    while (loop_vars.count(var)) {
        var = var_name(false);
    }
    vars.push_back(var);
    loop_vars.insert(var);
    int len = rnd.next(range / 2, range);

    if (loop_type == 0 && !values.empty()) {
        string x = values.begin()->first;
        string y = var_name();
        lines.push_back(indent + format("%s = %s + %d", y.c_str(), x.c_str(), len - 1));
        lines.push_back(indent + format("for %s = %s...%s", var.c_str(), x.c_str(), y.c_str()));
    } else if (loop_type == 1 && !values.empty()) {
        string x = values.begin()->first;
        int y = max(0, values[x] + len);
        lines.push_back(indent + format("for %s = %s...%d", var.c_str(), x.c_str(), y));
    } else if (loop_type == 2 && !values.empty()) {
        string x = values.begin()->first;
        int y = max(0, values[x] - len);
        lines.push_back(indent + format("for %s = %d...%s", var.c_str(), y, x.c_str()));
    } else {
        int a = rnd.next(900 - len), b = a + len - 1;
        lines.push_back(indent + format("for %s = %d...%d {", var.c_str(), a, b));
    }

    for (int i = 0; i < s && lines.size() + i < n; i++) {
        print_block(d, indent + "    ");
    }

    auto it = std::find(vars.begin(), vars.end(), var);
    if (it != vars.end()) vars.erase(it);
    if (values.count(var)) values.erase(var);
    lines.push_back(indent + "}");
}

int main(int argc, char *argv[]) {

    registerGen(argc, argv, 1);
    n = opt<int>("n"), s = opt<int>("s");
    depth = opt<int>("depth"), range = opt<int>("range");
    int force = has_opt("force") ? opt<int>("force") : 10;

    while (lines.size() < n - 5) {
        if (rnd.next(force) == 0) {
            print_loop(0, "");
        } else {
            print_block(0, "");
        }
    }
    println(lines.size());
    for (string const &line : lines) {
        println(line);
    }

}