import sys

sys.setrecursionlimit(10 ** 5)

n = int(input())
lines = [input() for _ in range(n)]
var_counter = 0
macro_counter = 0
output = []


def new_var():
    global var_counter
    var_counter += 1
    return f'x{var_counter:05d}'


def new_macro():
    global macro_counter
    macro_counter += 1
    mc = macro_counter
    name = ''
    while mc > 0:
        name += chr(ord('a') + mc % 26)
        mc //= 26
    return name


it = 0


def parse(outer_var):
    global it
    data = []

    while it <= len(lines):
        if it == len(lines) or lines[it].strip() == '}':
            macro_name = new_macro()
            output.append(f'MACRO {macro_name}:')
            if outer_var is not None:
                data.append(f'{outer_var} GETS {outer_var} + 1')
            for cmd in data:
                output.append(' ' * 4 + cmd)
            output.append('')
            it += 1
            return macro_name

        line = lines[it].strip()
        it += 1
        if line.startswith('for '):
            args = line[4:].split(' = ')
            var, values = args[0], args[1][:-2].split('...')
            repeat_counter = new_var()
            nested_macro = parse(var)
            data += [
                f'{var} GETS {values[0]}',
                f'{repeat_counter} GETS {values[1]} - {values[0]}',
                f'{repeat_counter} GETS {repeat_counter} + 1',
                f'REPEAT {nested_macro} {repeat_counter}'
            ]
        elif '=' in line:
            var, expr = line.split(' = ')
            data.append(f'{var} GETS {expr}')
        else:
            cmd, arg = line.split('(')
            data.append(f'{cmd.upper()} {arg[:-1]}')


name = parse(None)
output.append(f'REPEAT {name} 1')

print(len(output))
for line in output:
    print(line)