#include <numeric>
#include "testlib.h"

#define all(c) c.begin(), c.end()

using namespace std;

int main(int argc, char *argv[]) {

    registerGen(argc, argv, 1);
    int n = opt<int>("n"), m = opt<int>("m"), grow = opt<int>("grow");
    int amin = opt<int>("amin"), amax = opt<int>("amax");

    vector<int> p(n), perm(n);
    iota(all(perm), 0);
    shuffle(all(perm));
    for (int i = 0; i < n; i++) {
        p[i] = rnd.next(amin, amax);
    }

    vector<pair<int, int>> e;
    for (int i = 1; i < n; i++) {
        int par = rnd.wnext(0, i - 1, grow);
        e.push_back({i, par});
    }
    for (int i = n; i <= m; i++) {
        int u = rnd.wnext(0, n - 1, -grow);
        int v = rnd.wnext(0, n - 1, grow);
        while (u == v) {
            u = rnd.wnext(0, n - 1, -grow);
            v = rnd.wnext(0, n - 1, grow);
        }
        e.push_back({u, v});
    }

    println(n, m);
    println(all(p));
    for (int i = 0; i < m; i++) {
        int w = rnd.next(amin, amax);
        println(perm[e[i].first] + 1, perm[e[i].second] + 1, w);
    }

}