#include "testlib.h"

using namespace std;

int main(int argc, char *argv[]) {

    registerValidation(argc, argv);

    int const LIMIT = 200'000;
    int const ALIMIT = 1000'000'000;

    int n = inf.readInt(1, LIMIT, "n");
    inf.readSpace();
    int m = inf.readInt(1, LIMIT, "m");
    inf.readEoln();

    inf.readInts(n, 0, ALIMIT, "p");
    inf.readEoln();

    vector<vector<int>> g(n);
    for (int i = 0; i < m; i++) {
        int u = inf.readInt(1, n, format("u_%d", i + 1)) - 1;
        inf.readSpace();
        int v = inf.readInt(1, n, format("v_%d", i + 1)) - 1;
        inf.readSpace();
        inf.readInt(0, ALIMIT, format("d_{%d,%d}", u + 1, v + 1));
        inf.readEoln();

        ensuref(u != v, "graph contains a loop on vertex %d", v + 1);
        g[u].push_back(v);
        g[v].push_back(u);
    }

    inf.readEof();

    vector<int> vis(n, false);
    function<void(int)> dfs = [&](int v) {
        vis[v] = true;
        for (int u : g[v]) {
            if (vis[u]) continue;
            dfs(u);
        }
    };
    dfs(0);

    for (int i = 0; i < n; i++) {
        ensuref(vis[i], "vertex %d is not reachable from vertex 1", i + 1);
    }

}