/*
    @author: doreshnikov
    Daniil Oreshnikov, ITMO University
*/

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned int uint;
typedef pair<int, int> pii;

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &p) {
    return in >> p.first >> p.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &item : v)
        in >> item;
    return in;
}

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}
#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

#define all(c) c.begin(), c.end()

struct dsu {
    vector<int> p, r;

    dsu(int n) : p(n), r(n) {
        iota(all(p), 0);
    }

    int get(int v) {
        if (v == p[v]) return v;
        return p[v] = get(p[v]);
    }

    void join(int u, int v) {
        u = get(u), v = get(v);
        if (r[v] < r[u]) swap(v, u);
        p[u] = v;
        r[v] += r[v] == r[u];
    }
};

struct edge {
    int u, v;
    unsigned int w;

    bool operator<(edge const &other) const {
        return w < other.w;
    }
};

istream &operator>>(istream &in, edge &e) {
    return in >> e.u >> e.v >> e.w;
}

int main() {
    
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    in(int, n, m)
    vector<int> p(n);
    for (int i = 0; i < n; i++) {
        cin >> p[i];
    }

    vector<edge> d(m);
    for (int i = 0; i < m; i++) {
        cin >> d[i];
        d[i].w = (d[i].w ^ p[--d[i].u]) + (d[i].w ^ p[--d[i].v]);
    }

    sort(all(d));
    dsu cmp(n);
    long long total = 0;
    for (auto &e : d) {
        if (cmp.get(e.u) == cmp.get(e.v)) continue;
        total += e.w;
        cmp.join(e.u, e.v);
    }

    cout << total << '\n';

}